---
lang: en
title: 'API docs: metadata.designtimemethodmetadata'
keywords: LoopBack 4.0, LoopBack 4, Node.js, TypeScript, OpenAPI
sidebar: lb4_sidebar
editurl: https://github.com/loopbackio/loopback-next/tree/master/packages/metadata
permalink: /doc/en/lb4/apidocs.metadata.designtimemethodmetadata.html
---

<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@loopback/metadata](./metadata.md) &gt; [DesignTimeMethodMetadata](./metadata.designtimemethodmetadata.md)

## DesignTimeMethodMetadata interface

Design time metadata for a method.

**Signature:**

```typescript
export interface DesignTimeMethodMetadata 
```

## Example


```ts
class MyController
{
  myMethod(x: string, y: number, z: MyClass): boolean {
    // ...
    return true;
  }
}
```
The `myMethod` above has design-time metadata as follows:

```ts
{
  type: Function,
  parameterTypes: [String, Number, MyClass],
  returnType: Boolean
}
```

## Properties

|  Property | Modifiers | Type | Description |
|  --- | --- | --- | --- |
|  [parameterTypes](./metadata.designtimemethodmetadata.parametertypes.md) |  | Function\[\] | An array of parameter types. |
|  [returnType](./metadata.designtimemethodmetadata.returntype.md) |  | Function \| undefined | Return type, may be <code>undefined</code> (e.g. for constructors). |
|  [type](./metadata.designtimemethodmetadata.type.md) |  | Function \| undefined | Type of the method itself. It is <code>Function</code> for methods, <code>undefined</code> for the constructor. |


